Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 75772)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -2559,458 +1546,1189 @@
 
     cis = (CHUNK_ITEM_STRIPE*)&ci[1];
 
-    context = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_data_context), ALLOC_TAG);
-    if (!context) {
+    RtlZeroMemory(&context, sizeof(read_data_context));
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+
+    context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_data_stripe) * ci->num_stripes, ALLOC_TAG);
+    if (!context.stripes) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    RtlZeroMemory(context, sizeof(read_data_context));
-    KeInitializeEvent(&context->Event, NotificationEvent, FALSE);
-    
-    context->stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_data_stripe) * ci->num_stripes, ALLOC_TAG);
-    if (!context->stripes) {
-        ERR("out of memory\n");
-        ExFreePool(context);
-        return STATUS_INSUFFICIENT_RESOURCES;
+
+    if (c && (type == BLOCK_FLAG_RAID5 || type == BLOCK_FLAG_RAID6)) {
+        get_raid56_lock_range(c, addr, length, &lockaddr, &locklen);
+        chunk_lock_range(Vcb, c, lockaddr, locklen);
     }
-    
-    RtlZeroMemory(context->stripes, sizeof(read_data_stripe) * ci->num_stripes);
-    
-    context->buflen = length;
-    context->num_stripes = ci->num_stripes;
-    context->stripes_left = context->num_stripes;
-    context->sector_size = Vcb->superblock.sector_size;
-    context->csum = csum;
-    context->tree = is_tree;
-    context->type = type;
-    context->check_nocsum_parity = check_nocsum_parity;
-    
-    stripestart = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT64) * ci->num_stripes, ALLOC_TAG);
-    if (!stripestart) {
-        ERR("out of memory\n");
-        ExFreePool(context);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    stripeend = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT64) * ci->num_stripes, ALLOC_TAG);
-    if (!stripeend) {
-        ERR("out of memory\n");
-        ExFreePool(stripestart);
-        ExFreePool(context);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
+
+    RtlZeroMemory(context.stripes, sizeof(read_data_stripe) * ci->num_stripes);
+
+    context.buflen = length;
+    context.num_stripes = ci->num_stripes;
+    context.stripes_left = context.num_stripes;
+    context.sector_size = Vcb->superblock.sector_size;
+    context.csum = csum;
+    context.tree = is_tree;
+    context.type = type;
+
     if (type == BLOCK_FLAG_RAID0) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe;
-        
+        UINT16 endoffstripe, stripe;
+        UINT32 *stripeoff, pos;
+        PMDL master_mdl;
+        PFN_NUMBER* pfns;
+
+        // FIXME - test this still works if page size isn't the same as sector size
+
+        // This relies on the fact that MDLs are followed in memory by the page file numbers,
+        // so with a bit of jiggery-pokery you can trick your disks into deinterlacing your RAID0
+        // data for you without doing a memcpy yourself.
+        // MDLs are officially opaque, so this might very well break in future versions of Windows.
+
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes, &endoff, &endoffstripe);
-        
+
+        if (file_read) {
+            // Unfortunately we can't avoid doing at least one memcpy, as Windows can give us an MDL
+            // with duplicated dummy PFNs, which confuse check_csum. Ah well.
+            // See https://msdn.microsoft.com/en-us/library/windows/hardware/Dn614012.aspx if you're interested.
+
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+        } else
+            context.va = buf;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(master_mdl);
+            goto exit;
+        }
+
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+
         for (i = 0; i < ci->num_stripes; i++) {
-            if (startoffstripe > i) {
-                stripestart[i] = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                stripestart[i] = startoff;
-            } else {
-                stripestart[i] = startoff - (startoff % ci->stripe_length);
+            if (startoffstripe > i)
+                context.stripes[i].stripestart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+            else if (startoffstripe == i)
+                context.stripes[i].stripestart = startoff;
+            else
+                context.stripes[i].stripestart = startoff - (startoff % ci->stripe_length);
+
+            if (endoffstripe > i)
+                context.stripes[i].stripeend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+            else if (endoffstripe == i)
+                context.stripes[i].stripeend = endoff + 1;
+            else
+                context.stripes[i].stripeend = endoff - (endoff % ci->stripe_length);
+
+            if (context.stripes[i].stripestart != context.stripes[i].stripeend) {
+                context.stripes[i].mdl = IoAllocateMdl(context.va, (ULONG)(context.stripes[i].stripeend - context.stripes[i].stripestart), FALSE, FALSE, NULL);
+
+                if (!context.stripes[i].mdl) {
+                    ERR("IoAllocateMdl failed\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto exit;
+                }
             }
-            
-            if (endoffstripe > i) {
-                stripeend[i] = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stripeend[i] = endoff + 1;
+        }
+
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
+
+        pos = 0;
+        stripe = startoffstripe;
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+
+            if (pos == 0) {
+                UINT32 readlen = (UINT32)min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length - (context.stripes[stripe].stripestart % ci->stripe_length));
+
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                stripeoff[stripe] += readlen;
+                pos += readlen;
+            } else if (length - pos < ci->stripe_length) {
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (length - pos) * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                pos = length;
             } else {
-                stripeend[i] = endoff - (endoff % ci->stripe_length);
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (ULONG)(ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT));
+
+                stripeoff[stripe] += (UINT32)ci->stripe_length;
+                pos += (UINT32)ci->stripe_length;
             }
+
+            stripe = (stripe + 1) % ci->num_stripes;
         }
+
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
     } else if (type == BLOCK_FLAG_RAID10) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe, j;
-        
+        UINT16 endoffstripe, j, stripe;
+        ULONG orig_ls;
+        PMDL master_mdl;
+        PFN_NUMBER* pfns;
+        UINT32* stripeoff, pos;
+        read_data_stripe** stripes;
+
+        if (c)
+            orig_ls = c->last_stripe;
+        else
+            orig_ls = 0;
+
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes / ci->sub_stripes, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes / ci->sub_stripes, &endoff, &endoffstripe);
-        
+
         if ((ci->num_stripes % ci->sub_stripes) != 0) {
             ERR("chunk %llx: num_stripes %x was not a multiple of sub_stripes %x!\n", offset, ci->num_stripes, ci->sub_stripes);
             Status = STATUS_INTERNAL_ERROR;
             goto exit;
         }
-        
-        context->firstoff = (startoff % ci->stripe_length) / Vcb->superblock.sector_size;
-        context->startoffstripe = startoffstripe;
-        context->sectors_per_stripe = ci->stripe_length / Vcb->superblock.sector_size;
-        
+
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+        } else
+            context.va = buf;
+
+        context.firstoff = (UINT16)((startoff % ci->stripe_length) / Vcb->superblock.sector_size);
+        context.startoffstripe = startoffstripe;
+        context.sectors_per_stripe = (UINT16)(ci->stripe_length / Vcb->superblock.sector_size);
+
         startoffstripe *= ci->sub_stripes;
         endoffstripe *= ci->sub_stripes;
-        
+
+        if (c)
+            c->last_stripe = (orig_ls + 1) % ci->sub_stripes;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(master_mdl);
+            goto exit;
+        }
+
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+
+        stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(read_data_stripe*) * ci->num_stripes / ci->sub_stripes, ALLOC_TAG);
+        if (!stripes) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripes, sizeof(read_data_stripe*) * ci->num_stripes / ci->sub_stripes);
+
         for (i = 0; i < ci->num_stripes; i += ci->sub_stripes) {
-            if (startoffstripe > i) {
-                stripestart[i] = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                stripestart[i] = startoff;
-            } else {
-                stripestart[i] = startoff - (startoff % ci->stripe_length);
+            UINT64 sstart, send;
+            BOOL stripeset = FALSE;
+
+            if (startoffstripe > i)
+                sstart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+            else if (startoffstripe == i)
+                sstart = startoff;
+            else
+                sstart = startoff - (startoff % ci->stripe_length);
+
+            if (endoffstripe > i)
+                send = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+            else if (endoffstripe == i)
+                send = endoff + 1;
+            else
+                send = endoff - (endoff % ci->stripe_length);
+
+            for (j = 0; j < ci->sub_stripes; j++) {
+                if (j == orig_ls && devices[i+j] && devices[i+j]->devobj) {
+                    context.stripes[i+j].stripestart = sstart;
+                    context.stripes[i+j].stripeend = send;
+                    stripes[i / ci->sub_stripes] = &context.stripes[i+j];
+
+                    if (sstart != send) {
+                        context.stripes[i+j].mdl = IoAllocateMdl(context.va, (ULONG)(send - sstart), FALSE, FALSE, NULL);
+
+                        if (!context.stripes[i+j].mdl) {
+                            ERR("IoAllocateMdl failed\n");
+                            Status = STATUS_INSUFFICIENT_RESOURCES;
+                            goto exit;
+                        }
+                    }
+
+                    stripeset = TRUE;
+                } else
+                    context.stripes[i+j].status = ReadDataStatus_Skip;
             }
-            
-            if (endoffstripe > i) {
-                stripeend[i] = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stripeend[i] = endoff + 1;
+
+            if (!stripeset) {
+                for (j = 0; j < ci->sub_stripes; j++) {
+                    if (devices[i+j] && devices[i+j]->devobj) {
+                        context.stripes[i+j].stripestart = sstart;
+                        context.stripes[i+j].stripeend = send;
+                        context.stripes[i+j].status = ReadDataStatus_Pending;
+                        stripes[i / ci->sub_stripes] = &context.stripes[i+j];
+
+                        if (sstart != send) {
+                            context.stripes[i+j].mdl = IoAllocateMdl(context.va, (ULONG)(send - sstart), FALSE, FALSE, NULL);
+
+                            if (!context.stripes[i+j].mdl) {
+                                ERR("IoAllocateMdl failed\n");
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                goto exit;
+                            }
+                        }
+
+                        stripeset = TRUE;
+                        break;
+                    }
+                }
+
+                if (!stripeset) {
+                    ERR("could not find stripe to read\n");
+                    Status = STATUS_DEVICE_NOT_READY;
+                    goto exit;
+                }
+            }
+        }
+
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes / ci->sub_stripes);
+
+        pos = 0;
+        stripe = startoffstripe / ci->sub_stripes;
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns = (PFN_NUMBER*)(stripes[stripe]->mdl + 1);
+
+            if (pos == 0) {
+                UINT32 readlen = (UINT32)min(stripes[stripe]->stripeend - stripes[stripe]->stripestart,
+                                             ci->stripe_length - (stripes[stripe]->stripestart % ci->stripe_length));
+
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                stripeoff[stripe] += readlen;
+                pos += readlen;
+            } else if (length - pos < ci->stripe_length) {
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (length - pos) * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                pos = length;
             } else {
-                stripeend[i] = endoff - (endoff % ci->stripe_length);
+                RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (ULONG)(ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT));
+
+                stripeoff[stripe] += (ULONG)ci->stripe_length;
+                pos += (ULONG)ci->stripe_length;
             }
-            
-            for (j = 1; j < ci->sub_stripes; j++) {
-                stripestart[i+j] = stripestart[i];
-                stripeend[i+j] = stripeend[i];
-            }
+
+            stripe = (stripe + 1) % (ci->num_stripes / ci->sub_stripes);
         }
-        
-        context->stripes_cancel = 1;
+
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
+        ExFreePool(stripes);
     } else if (type == BLOCK_FLAG_DUPLICATE) {
-        for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = addr - offset;
-            stripeend[i] = stripestart[i] + length;
+        UINT64 orig_ls;
+
+        if (c)
+            orig_ls = i = c->last_stripe;
+        else
+            orig_ls = i = 0;
+
+        while (!devices[i] || !devices[i]->devobj) {
+            i = (i + 1) % ci->num_stripes;
+
+            if (i == orig_ls) {
+                ERR("no devices available to service request\n");
+                Status = STATUS_DEVICE_NOT_READY;
+                goto exit;
+            }
         }
-        
-        context->stripes_cancel = ci->num_stripes - 1;
+
+        if (c)
+            c->last_stripe = (i + 1) % ci->num_stripes;
+
+        context.stripes[i].stripestart = addr - offset;
+        context.stripes[i].stripeend = context.stripes[i].stripestart + length;
+
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+
+            context.stripes[i].mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+            if (!context.stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+
+            MmBuildMdlForNonPagedPool(context.stripes[i].mdl);
+        } else {
+            context.stripes[i].mdl = IoAllocateMdl(buf, length, FALSE, FALSE, NULL);
+
+            if (!context.stripes[i].mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+
+            Status = STATUS_SUCCESS;
+
+            _SEH2_TRY {
+                MmProbeAndLockPages(context.stripes[i].mdl, KernelMode, IoWriteAccess);
+            } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                Status = _SEH2_GetExceptionCode();
+            } _SEH2_END;
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+                goto exit;
+            }
+        }
     } else if (type == BLOCK_FLAG_RAID5) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe;
-        UINT64 start = 0xffffffffffffffff, end = 0;
-        
+        UINT16 endoffstripe, parity;
+        UINT32 *stripeoff, pos;
+        PMDL master_mdl;
+        PFN_NUMBER *pfns, dummy;
+        BOOL need_dummy = FALSE;
+
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 1, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes - 1, &endoff, &endoffstripe);
-        
-        for (i = 0; i < ci->num_stripes - 1; i++) {
-            UINT64 ststart, stend;
-            
-            if (startoffstripe > i) {
-                ststart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                ststart = startoff;
-            } else {
-                ststart = startoff - (startoff % ci->stripe_length);
+
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
             }
-              
-            if (endoffstripe > i) {
-                stend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stend = endoff + 1;
+        } else
+            context.va = buf;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(master_mdl);
+            goto exit;
+        }
+
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+
+        pos = 0;
+        while (pos < length) {
+            parity = (((addr - offset + pos) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
+
+            if (pos == 0) {
+                UINT16 stripe = (parity + startoffstripe + 1) % ci->num_stripes;
+                ULONG skip, readlen;
+
+                i = startoffstripe;
+                while (stripe != parity) {
+                    if (i == startoffstripe) {
+                        readlen = min(length, (ULONG)(ci->stripe_length - (startoff % ci->stripe_length)));
+
+                        context.stripes[stripe].stripestart = startoff;
+                        context.stripes[stripe].stripeend = startoff + readlen;
+
+                        pos += readlen;
+
+                        if (pos == length)
+                            break;
+                    } else {
+                        readlen = min(length - pos, (ULONG)ci->stripe_length);
+
+                        context.stripes[stripe].stripestart = startoff - (startoff % ci->stripe_length);
+                        context.stripes[stripe].stripeend = context.stripes[stripe].stripestart + readlen;
+
+                        pos += readlen;
+
+                        if (pos == length)
+                            break;
+                    }
+
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+
+                if (pos == length)
+                    break;
+
+                for (i = 0; i < startoffstripe; i++) {
+                    UINT16 stripe2 = (parity + i + 1) % ci->num_stripes;
+
+                    context.stripes[stripe2].stripestart = context.stripes[stripe2].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                }
+
+                context.stripes[parity].stripestart = context.stripes[parity].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+
+                if (length - pos > ci->num_stripes * (ci->num_stripes - 1) * ci->stripe_length) {
+                    skip = (ULONG)(((length - pos) / (ci->num_stripes * (ci->num_stripes - 1) * ci->stripe_length)) - 1);
+
+                    for (i = 0; i < ci->num_stripes; i++) {
+                        context.stripes[i].stripeend += skip * ci->num_stripes * ci->stripe_length;
+                    }
+
+                    pos += (UINT32)(skip * (ci->num_stripes - 1) * ci->num_stripes * ci->stripe_length);
+                    need_dummy = TRUE;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 1)) {
+                for (i = 0; i < ci->num_stripes; i++) {
+                    context.stripes[i].stripeend += ci->stripe_length;
+                }
+
+                pos += (UINT32)(ci->stripe_length * (ci->num_stripes - 1));
+                need_dummy = TRUE;
             } else {
-                stend = endoff - (endoff % ci->stripe_length);
-            }
-            
-            if (ststart != stend) {
-                if (ststart < start) {
-                    start = ststart;
-                    firststripesize = ci->stripe_length - (ststart % ci->stripe_length);
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+
+                i = 0;
+                while (stripe != parity) {
+                    if (endoffstripe == i) {
+                        context.stripes[stripe].stripeend = endoff + 1;
+                        break;
+                    } else if (endoffstripe > i)
+                        context.stripes[stripe].stripeend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
                 }
-                
-                if (stend > end)
-                    end = stend;
+
+                break;
             }
         }
-        
+
         for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = start;
-            stripeend[i] = end;
+            if (context.stripes[i].stripestart != context.stripes[i].stripeend) {
+                context.stripes[i].mdl = IoAllocateMdl(context.va, (ULONG)(context.stripes[i].stripeend - context.stripes[i].stripestart),
+                                                       FALSE, FALSE, NULL);
+
+                if (!context.stripes[i].mdl) {
+                    ERR("IoAllocateMdl failed\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto exit;
+                }
+            }
         }
-        
-        context->stripes_cancel = Vcb->options.raid5_recalculation;
+
+        if (need_dummy) {
+            dummypage = ExAllocatePoolWithTag(NonPagedPool, PAGE_SIZE, ALLOC_TAG);
+            if (!dummypage) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+
+            dummy_mdl = IoAllocateMdl(dummypage, PAGE_SIZE, FALSE, FALSE, NULL);
+            if (!dummy_mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                ExFreePool(dummypage);
+                goto exit;
+            }
+
+            MmBuildMdlForNonPagedPool(dummy_mdl);
+
+            dummy = *(PFN_NUMBER*)(dummy_mdl + 1);
+        }
+
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
+
+        pos = 0;
+
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns;
+
+            parity = (((addr - offset + pos) / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
+
+            if (pos == 0) {
+                UINT16 stripe = (parity + startoffstripe + 1) % ci->num_stripes;
+                UINT32 readlen = min(length - pos, (UINT32)min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart,
+                                                       ci->stripe_length - (context.stripes[stripe].stripestart % ci->stripe_length)));
+
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                stripeoff[stripe] = readlen;
+                pos += readlen;
+
+                stripe = (stripe + 1) % ci->num_stripes;
+
+                while (stripe != parity) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, (UINT32)min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+
+                    if (readlen == 0)
+                        break;
+
+                    RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                    stripeoff[stripe] = readlen;
+                    pos += readlen;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 1)) {
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+                ULONG k;
+
+                while (stripe != parity) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (ULONG)(ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT));
+
+                    stripeoff[stripe] += (UINT32)ci->stripe_length;
+                    pos += (UINT32)ci->stripe_length;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity].mdl + 1);
+
+                for (k = 0; k < ci->stripe_length >> PAGE_SHIFT; k++) {
+                    stripe_pfns[stripeoff[parity] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity] += PAGE_SIZE;
+                }
+            } else {
+                UINT16 stripe = (parity + 1) % ci->num_stripes;
+                UINT32 readlen;
+
+                while (pos < length) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = min(length - pos, (ULONG)min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+
+                    if (readlen == 0)
+                        break;
+
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                    stripeoff[stripe] += readlen;
+                    pos += readlen;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            }
+        }
+
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
     } else if (type == BLOCK_FLAG_RAID6) {
         UINT64 startoff, endoff;
-        UINT16 endoffstripe;
-        UINT64 start = 0xffffffffffffffff, end = 0;
-        
+        UINT16 endoffstripe, parity1;
+        UINT32 *stripeoff, pos;
+        PMDL master_mdl;
+        PFN_NUMBER *pfns, dummy;
+        BOOL need_dummy = FALSE;
+
         get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes - 2, &startoff, &startoffstripe);
         get_raid0_offset(addr + length - offset - 1, ci->stripe_length, ci->num_stripes - 2, &endoff, &endoffstripe);
-        
-        for (i = 0; i < ci->num_stripes - 2; i++) {
-            UINT64 ststart, stend;
-            
-            if (startoffstripe > i) {
-                ststart = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
-            } else if (startoffstripe == i) {
-                ststart = startoff;
-            } else {
-                ststart = startoff - (startoff % ci->stripe_length);
+
+        if (file_read) {
+            context.va = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
+
+            if (!context.va) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
             }
-              
-            if (endoffstripe > i) {
-                stend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
-            } else if (endoffstripe == i) {
-                stend = endoff + 1;
+        } else
+            context.va = buf;
+
+        master_mdl = IoAllocateMdl(context.va, length, FALSE, FALSE, NULL);
+        if (!master_mdl) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(master_mdl, KernelMode, IoWriteAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(master_mdl);
+            goto exit;
+        }
+
+        pfns = (PFN_NUMBER*)(master_mdl + 1);
+
+        pos = 0;
+        while (pos < length) {
+            parity1 = (((addr - offset + pos) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
+
+            if (pos == 0) {
+                UINT16 stripe = (parity1 + startoffstripe + 2) % ci->num_stripes, parity2;
+                ULONG skip, readlen;
+
+                i = startoffstripe;
+                while (stripe != parity1) {
+                    if (i == startoffstripe) {
+                        readlen = (ULONG)min(length, ci->stripe_length - (startoff % ci->stripe_length));
+
+                        context.stripes[stripe].stripestart = startoff;
+                        context.stripes[stripe].stripeend = startoff + readlen;
+
+                        pos += readlen;
+
+                        if (pos == length)
+                            break;
+                    } else {
+                        readlen = min(length - pos, (ULONG)ci->stripe_length);
+
+                        context.stripes[stripe].stripestart = startoff - (startoff % ci->stripe_length);
+                        context.stripes[stripe].stripeend = context.stripes[stripe].stripestart + readlen;
+
+                        pos += readlen;
+
+                        if (pos == length)
+                            break;
+                    }
+
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+
+                if (pos == length)
+                    break;
+
+                for (i = 0; i < startoffstripe; i++) {
+                    UINT16 stripe2 = (parity1 + i + 2) % ci->num_stripes;
+
+                    context.stripes[stripe2].stripestart = context.stripes[stripe2].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+                }
+
+                context.stripes[parity1].stripestart = context.stripes[parity1].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+
+                parity2 = (parity1 + 1) % ci->num_stripes;
+                context.stripes[parity2].stripestart = context.stripes[parity2].stripeend = startoff - (startoff % ci->stripe_length) + ci->stripe_length;
+
+                if (length - pos > ci->num_stripes * (ci->num_stripes - 2) * ci->stripe_length) {
+                    skip = (ULONG)(((length - pos) / (ci->num_stripes * (ci->num_stripes - 2) * ci->stripe_length)) - 1);
+
+                    for (i = 0; i < ci->num_stripes; i++) {
+                        context.stripes[i].stripeend += skip * ci->num_stripes * ci->stripe_length;
+                    }
+
+                    pos += (UINT32)(skip * (ci->num_stripes - 2) * ci->num_stripes * ci->stripe_length);
+                    need_dummy = TRUE;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 2)) {
+                for (i = 0; i < ci->num_stripes; i++) {
+                    context.stripes[i].stripeend += ci->stripe_length;
+                }
+
+                pos += (UINT32)(ci->stripe_length * (ci->num_stripes - 2));
+                need_dummy = TRUE;
             } else {
-                stend = endoff - (endoff % ci->stripe_length);
-            }
-            
-            if (ststart != stend) {
-                if (ststart < start) {
-                    start = ststart;
-                    firststripesize = ci->stripe_length - (ststart % ci->stripe_length);
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+
+                i = 0;
+                while (stripe != parity1) {
+                    if (endoffstripe == i) {
+                        context.stripes[stripe].stripeend = endoff + 1;
+                        break;
+                    } else if (endoffstripe > i)
+                        context.stripes[stripe].stripeend = endoff - (endoff % ci->stripe_length) + ci->stripe_length;
+
+                    i++;
+                    stripe = (stripe + 1) % ci->num_stripes;
                 }
-                
-                if (stend > end)
-                    end = stend;
+
+                break;
             }
         }
-        
+
         for (i = 0; i < ci->num_stripes; i++) {
-            stripestart[i] = start;
-            stripeend[i] = end;
+            if (context.stripes[i].stripestart != context.stripes[i].stripeend) {
+                context.stripes[i].mdl = IoAllocateMdl(context.va, (ULONG)(context.stripes[i].stripeend - context.stripes[i].stripestart), FALSE, FALSE, NULL);
+
+                if (!context.stripes[i].mdl) {
+                    ERR("IoAllocateMdl failed\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto exit;
+                }
+            }
         }
-        
-        context->stripes_cancel = Vcb->options.raid6_recalculation;
+
+        if (need_dummy) {
+            dummypage = ExAllocatePoolWithTag(NonPagedPool, PAGE_SIZE, ALLOC_TAG);
+            if (!dummypage) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto exit;
+            }
+
+            dummy_mdl = IoAllocateMdl(dummypage, PAGE_SIZE, FALSE, FALSE, NULL);
+            if (!dummy_mdl) {
+                ERR("IoAllocateMdl failed\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                ExFreePool(dummypage);
+                goto exit;
+            }
+
+            MmBuildMdlForNonPagedPool(dummy_mdl);
+
+            dummy = *(PFN_NUMBER*)(dummy_mdl + 1);
+        }
+
+        stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
+        if (!stripeoff) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto exit;
+        }
+
+        RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
+
+        pos = 0;
+
+        while (pos < length) {
+            PFN_NUMBER* stripe_pfns;
+
+            parity1 = (((addr - offset + pos) / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
+
+            if (pos == 0) {
+                UINT16 stripe = (parity1 + startoffstripe + 2) % ci->num_stripes;
+                UINT32 readlen = min(length - pos, (UINT32)min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart,
+                                                       ci->stripe_length - (context.stripes[stripe].stripestart % ci->stripe_length)));
+
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+
+                RtlCopyMemory(stripe_pfns, pfns, readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                stripeoff[stripe] = readlen;
+                pos += readlen;
+
+                stripe = (stripe + 1) % ci->num_stripes;
+
+                while (stripe != parity1) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = (UINT32)min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+
+                    if (readlen == 0)
+                        break;
+
+                    RtlCopyMemory(stripe_pfns, &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                    stripeoff[stripe] = readlen;
+                    pos += readlen;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            } else if (length - pos >= ci->stripe_length * (ci->num_stripes - 2)) {
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+                UINT16 parity2 = (parity1 + 1) % ci->num_stripes;
+                ULONG k;
+
+                while (stripe != parity1) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], (ULONG)(ci->stripe_length * sizeof(PFN_NUMBER) >> PAGE_SHIFT));
+
+                    stripeoff[stripe] += (UINT32)ci->stripe_length;
+                    pos += (UINT32)ci->stripe_length;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity1].mdl + 1);
+
+                for (k = 0; k < ci->stripe_length >> PAGE_SHIFT; k++) {
+                    stripe_pfns[stripeoff[parity1] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity1] += PAGE_SIZE;
+                }
+
+                stripe_pfns = (PFN_NUMBER*)(context.stripes[parity2].mdl + 1);
+
+                for (k = 0; k < ci->stripe_length >> PAGE_SHIFT; k++) {
+                    stripe_pfns[stripeoff[parity2] >> PAGE_SHIFT] = dummy;
+                    stripeoff[parity2] += PAGE_SIZE;
+                }
+            } else {
+                UINT16 stripe = (parity1 + 2) % ci->num_stripes;
+                UINT32 readlen;
+
+                while (pos < length) {
+                    stripe_pfns = (PFN_NUMBER*)(context.stripes[stripe].mdl + 1);
+                    readlen = (UINT32)min(length - pos, min(context.stripes[stripe].stripeend - context.stripes[stripe].stripestart, ci->stripe_length));
+
+                    if (readlen == 0)
+                        break;
+
+                    RtlCopyMemory(&stripe_pfns[stripeoff[stripe] >> PAGE_SHIFT], &pfns[pos >> PAGE_SHIFT], readlen * sizeof(PFN_NUMBER) >> PAGE_SHIFT);
+
+                    stripeoff[stripe] += readlen;
+                    pos += readlen;
+
+                    stripe = (stripe + 1) % ci->num_stripes;
+                }
+            }
+        }
+
+        MmUnlockPages(master_mdl);
+        IoFreeMdl(master_mdl);
+
+        ExFreePool(stripeoff);
     }
-    
-    KeInitializeSpinLock(&context->spin_lock);
-    
-    context->address = addr;
-    
+
+    context.address = addr;
+
     for (i = 0; i < ci->num_stripes; i++) {
-        if (!devices[i] || stripestart[i] == stripeend[i]) {
-            context->stripes[i].status = ReadDataStatus_MissingDevice;
-            context->stripes[i].buf = NULL;
-            context->stripes_left--;
-            
-            if (!devices[i])
+        if (!devices[i] || !devices[i]->devobj || context.stripes[i].stripestart == context.stripes[i].stripeend) {
+            context.stripes[i].status = ReadDataStatus_MissingDevice;
+            context.stripes_left--;
+
+            if (!devices[i] || !devices[i]->devobj)
                 missing_devices++;
         }
     }
-      
+
     if (missing_devices > allowed_missing) {
         ERR("not enough devices to service request (%u missing)\n", missing_devices);
         Status = STATUS_UNEXPECTED_IO_ERROR;
         goto exit;
     }
-    
+
     for (i = 0; i < ci->num_stripes; i++) {
         PIO_STACK_LOCATION IrpSp;
-        
-        if (devices[i] && stripestart[i] != stripeend[i]) {
-            context->stripes[i].context = (struct read_data_context*)context;
-            context->stripes[i].buf = ExAllocatePoolWithTag(NonPagedPool, stripeend[i] - stripestart[i], ALLOC_TAG);
-            
-            if (!context->stripes[i].buf) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto exit;
-            }
-            
+
+        if (devices[i] && devices[i]->devobj && context.stripes[i].stripestart != context.stripes[i].stripeend && context.stripes[i].status != ReadDataStatus_Skip) {
+            context.stripes[i].context = (struct read_data_context*)&context;
+
             if (type == BLOCK_FLAG_RAID10) {
-                context->stripes[i].stripenum = i / ci->sub_stripes;
+                context.stripes[i].stripenum = i / ci->sub_stripes;
             }
 
             if (!Irp) {
-                context->stripes[i].Irp = IoAllocateIrp(devices[i]->devobj->StackSize, FALSE);
-                
-                if (!context->stripes[i].Irp) {
+                context.stripes[i].Irp = IoAllocateIrp(devices[i]->devobj->StackSize, FALSE);
+
+                if (!context.stripes[i].Irp) {
                     ERR("IoAllocateIrp failed\n");
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto exit;
                 }
             } else {
-                context->stripes[i].Irp = IoMakeAssociatedIrp(Irp, devices[i]->devobj->StackSize);
-                
-                if (!context->stripes[i].Irp) {
+                context.stripes[i].Irp = IoMakeAssociatedIrp(Irp, devices[i]->devobj->StackSize);
+
+                if (!context.stripes[i].Irp) {
                     ERR("IoMakeAssociatedIrp failed\n");
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto exit;
                 }
             }
-            
-            IrpSp = IoGetNextIrpStackLocation(context->stripes[i].Irp);
+
+            IrpSp = IoGetNextIrpStackLocation(context.stripes[i].Irp);
             IrpSp->MajorFunction = IRP_MJ_READ;
-            
+
             if (devices[i]->devobj->Flags & DO_BUFFERED_IO) {
-                FIXME("FIXME - buffered IO\n");
-            } else if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                context->stripes[i].Irp->MdlAddress = IoAllocateMdl(context->stripes[i].buf, stripeend[i] - stripestart[i], FALSE, FALSE, NULL);
-                if (!context->stripes[i].Irp->MdlAddress) {
-                    ERR("IoAllocateMdl failed\n");
+                context.stripes[i].Irp->AssociatedIrp.SystemBuffer = ExAllocatePoolWithTag(NonPagedPool, (ULONG)(context.stripes[i].stripeend - context.stripes[i].stripestart), ALLOC_TAG);
+                if (!context.stripes[i].Irp->AssociatedIrp.SystemBuffer) {
+                    ERR("out of memory\n");
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto exit;
                 }
-                
-                MmProbeAndLockPages(context->stripes[i].Irp->MdlAddress, KernelMode, IoWriteAccess);
-            } else {
-                context->stripes[i].Irp->UserBuffer = context->stripes[i].buf;
-            }
 
-            IrpSp->Parameters.Read.Length = stripeend[i] - stripestart[i];
-            IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[i] + cis[i].offset;
-            
-            context->stripes[i].Irp->UserIosb = &context->stripes[i].iosb;
-            
-            IoSetCompletionRoutine(context->stripes[i].Irp, read_data_completion, &context->stripes[i], TRUE, TRUE, TRUE);
+                context.stripes[i].Irp->Flags |= IRP_BUFFERED_IO | IRP_DEALLOCATE_BUFFER | IRP_INPUT_OPERATION;
 
-            context->stripes[i].status = ReadDataStatus_Pending;
+                context.stripes[i].Irp->UserBuffer = MmGetSystemAddressForMdlSafe(context.stripes[i].mdl, priority);
+            } else if (devices[i]->devobj->Flags & DO_DIRECT_IO)
+                context.stripes[i].Irp->MdlAddress = context.stripes[i].mdl;
+            else
+                context.stripes[i].Irp->UserBuffer = MmGetSystemAddressForMdlSafe(context.stripes[i].mdl, priority);
+
+            IrpSp->Parameters.Read.Length = (ULONG)(context.stripes[i].stripeend - context.stripes[i].stripestart);
+            IrpSp->Parameters.Read.ByteOffset.QuadPart = context.stripes[i].stripestart + cis[i].offset;
+
+            total_reading += IrpSp->Parameters.Read.Length;
+
+            context.stripes[i].Irp->UserIosb = &context.stripes[i].iosb;
+
+            IoSetCompletionRoutine(context.stripes[i].Irp, read_data_completion, &context.stripes[i], TRUE, TRUE, TRUE);
+
+            context.stripes[i].status = ReadDataStatus_Pending;
         }
     }
-    
+
 #ifdef DEBUG_STATS
     if (!is_tree)
         time1 = KeQueryPerformanceCounter(NULL);
 #endif
-    
+
+    need_to_wait = FALSE;
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status != ReadDataStatus_MissingDevice) {
-            IoCallDriver(devices[i]->devobj, context->stripes[i].Irp);
+        if (context.stripes[i].status != ReadDataStatus_MissingDevice && context.stripes[i].status != ReadDataStatus_Skip) {
+            IoCallDriver(devices[i]->devobj, context.stripes[i].Irp);
+            need_to_wait = TRUE;
         }
     }
 
-    KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-   
+    if (need_to_wait)
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+
 #ifdef DEBUG_STATS
     if (!is_tree) {
         time2 = KeQueryPerformanceCounter(NULL);
-        
+
         Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
     }
 #endif
-    
+
+    if (diskacc)
+        fFsRtlUpdateDiskCounters(total_reading, 0);
+
     // check if any of the devices return a "user-induced" error
-    
+
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Error && IoIsErrorUserInduced(context->stripes[i].iosb.Status)) {
-            if (Irp && context->stripes[i].iosb.Status == STATUS_VERIFY_REQUIRED) {
-                PDEVICE_OBJECT dev;
-                
-                dev = IoGetDeviceToVerify(Irp->Tail.Overlay.Thread);
-                IoSetDeviceToVerify(Irp->Tail.Overlay.Thread, NULL);
-                
-                if (!dev) {
-                    dev = IoGetDeviceToVerify(PsGetCurrentThread());
-                    IoSetDeviceToVerify(PsGetCurrentThread(), NULL);
-                }
-                
-                dev = Vcb->Vpb ? Vcb->Vpb->RealDevice : NULL;
-                
-                if (dev)
-                    IoVerifyVolume(dev, FALSE);
-            }
-//             IoSetHardErrorOrVerifyDevice(context->stripes[i].Irp, devices[i]->devobj);
-            
-            Status = context->stripes[i].iosb.Status;
+        if (context.stripes[i].status == ReadDataStatus_Error && IoIsErrorUserInduced(context.stripes[i].iosb.Status)) {
+            Status = context.stripes[i].iosb.Status;
             goto exit;
         }
     }
-    
+
     if (type == BLOCK_FLAG_RAID0) {
-        Status = read_data_raid0(Vcb, buf, addr, length, context, ci, stripestart, stripeend, startoffstripe);
+        Status = read_data_raid0(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, generation, offset);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid0 returned %08x\n", Status);
+
+            if (file_read)
+                ExFreePool(context.va);
+
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_RAID10) {
-        Status = read_data_raid10(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, startoffstripe);
+        Status = read_data_raid10(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, generation, offset);
+
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid10 returned %08x\n", Status);
+
+            if (file_read)
+                ExFreePool(context.va);
+
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_DUPLICATE) {
-        Status = read_data_dup(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend);
+        Status = read_data_dup(Vcb, file_read ? context.va : buf, addr, &context, ci, devices, generation);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_dup returned %08x\n", Status);
+
+            if (file_read)
+                ExFreePool(context.va);
+
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_RAID5) {
-        Status = read_data_raid5(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, offset, firststripesize, check_nocsum_parity);
+        Status = read_data_raid5(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, offset, generation, c, missing_devices > 0 ? TRUE : FALSE);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid5 returned %08x\n", Status);
+
+            if (file_read)
+                ExFreePool(context.va);
+
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     } else if (type == BLOCK_FLAG_RAID6) {
-        Status = read_data_raid6(Vcb, buf, addr, length, Irp, context, ci, devices, stripestart, stripeend, offset, firststripesize, check_nocsum_parity);
+        Status = read_data_raid6(Vcb, file_read ? context.va : buf, addr, length, &context, ci, devices, offset, generation, c, missing_devices > 0 ? TRUE : FALSE);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data_raid6 returned %08x\n", Status);
+
+            if (file_read)
+                ExFreePool(context.va);
+
             goto exit;
         }
+
+        if (file_read) {
+            RtlCopyMemory(buf, context.va, length);
+            ExFreePool(context.va);
+        }
     }
 
 exit:
-    if (stripestart) ExFreePool(stripestart);
-    if (stripeend) ExFreePool(stripeend);
+    if (c && (type == BLOCK_FLAG_RAID5 || type == BLOCK_FLAG_RAID6))
+        chunk_unlock_range(Vcb, c, lockaddr, locklen);
 
+    if (dummy_mdl)
+        IoFreeMdl(dummy_mdl);
+
+    if (dummypage)
+        ExFreePool(dummypage);
+
     for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].Irp) {
-            if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                MmUnlockPages(context->stripes[i].Irp->MdlAddress);
-                IoFreeMdl(context->stripes[i].Irp->MdlAddress);
-            }
-            IoFreeIrp(context->stripes[i].Irp);
+        if (context.stripes[i].mdl) {
+            if (context.stripes[i].mdl->MdlFlags & MDL_PAGES_LOCKED)
+                MmUnlockPages(context.stripes[i].mdl);
+
+            IoFreeMdl(context.stripes[i].mdl);
         }
-        
-        if (context->stripes[i].buf)
-            ExFreePool(context->stripes[i].buf);
+
+        if (context.stripes[i].Irp)
+            IoFreeIrp(context.stripes[i].Irp);
     }
 
-    ExFreePool(context->stripes);
-    ExFreePool(context);
-    
+    ExFreePool(context.stripes);
+
     if (!Vcb->log_to_phys_loaded)
         ExFreePool(devices);
-        
+
     return Status;
 }
 
-static NTSTATUS STDCALL read_stream(fcb* fcb, UINT8* data, UINT64 start, ULONG length, ULONG* pbr) {
+NTSTATUS read_stream(fcb* fcb, UINT8* data, UINT64 start, ULONG length, ULONG* pbr) {
     ULONG readlen;
-    NTSTATUS Status;
-    
+
     TRACE("(%p, %p, %llx, %llx, %p)\n", fcb, data, start, length, pbr);
-    
+
     if (pbr) *pbr = 0;
-    
+
     if (start >= fcb->adsdata.Length) {
         TRACE("tried to read beyond end of stream\n");
         return STATUS_END_OF_FILE;
     }
-    
+
     if (length == 0) {
         WARN("tried to read zero bytes\n");
         return STATUS_SUCCESS;
     }
-    
+
     if (start + length < fcb->adsdata.Length)
         readlen = length;
     else
         readlen = fcb->adsdata.Length - (ULONG)start;
-    
+
     if (readlen > 0)
         RtlCopyMemory(data + start, fcb->adsdata.Buffer, readlen);
-    
+
     if (pbr) *pbr = readlen;
-    
-    Status = STATUS_SUCCESS;
-       
-    return Status;
+
+    return STATUS_SUCCESS;
 }
 
-NTSTATUS STDCALL read_file(fcb* fcb, UINT8* data, UINT64 start, UINT64 length, ULONG* pbr, PIRP Irp, BOOL check_nocsum_parity) {
+NTSTATUS read_file(fcb* fcb, UINT8* data, UINT64 start, UINT64 length, ULONG* pbr, PIRP Irp) {
     NTSTATUS Status;
     EXTENT_DATA* ed;
-    UINT64 bytes_read = 0;
+    UINT32 bytes_read = 0;
     UINT64 last_end;
     LIST_ENTRY* le;
 #ifdef DEBUG_STATS
     LARGE_INTEGER time1, time2;
 #endif
-    
+
     TRACE("(%p, %p, %llx, %llx, %p)\n", fcb, data, start, length, pbr);
-    
+
     if (pbr)
         *pbr = 0;
-    
+
     if (start >= fcb->inode_item.st_size) {
         WARN("Tried to read beyond end of file\n");
         Status = STATUS_END_OF_FILE;
-        goto exit;        
+        goto exit;
     }
-    
+
 #ifdef DEBUG_STATS
     time1 = KeQueryPerformanceCounter(NULL);
 #endif
